
RadioBox = {};

function RadioBox.prerequisitesPresent(specializations)
    return true;
end;

function RadioBox:load(xmlFile)
	-- Anfang Radio
	
    self.radioCount = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.radio#count"),0);
	self.radioVolume = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.radio#volume"),0);
    self.radioOn = false;
    self.radio = {};
	self.currentSong = 1;
    for i=1, self.radioCount do
        local objname = string.format("vehicle.radio.song" .. "%d",i);
        self.radio[i] = {};
        local filename = Utils.getFilename(getXMLString(xmlFile, objname .. "#filename"),self.baseDirectory);
		self.radio[i].song = createSample(string.format("track" .. "%d",i));
		loadSample(self.radio[i].song, filename, false);
    end;
	self.songPlayed = false;
	
	-- Ende Radio
	
    self.keys = {};
    local i=0;
    while true do
        local baseName = string.format("vehicle.keys.input(%d)", i);
        local inputName = getXMLString(xmlFile, baseName.. "#name");
        if inputName == nil then
            break;
        end;
        local inputKey = getXMLString(xmlFile, baseName.. "#key");
        if Input[inputKey] == nil then
            print("Error: invalid key '" .. inputKey .. "'  for input event '" .. inputName .. "'");
            break;
        end;
        self.keys[inputName] = Input[inputKey];
        i = i+1;
    end;
	
end;

function RadioBox:keyEvent(unicode, sym, modifier, isDown)
	-- Anfang Radio
	
	if isDown and sym == Input.KEY_f5 then
		self.radioOn = not self.radioOn;
	end;
	
	if isDown and sym == Input.KEY_f6 then
		stopSample(self.radio[self.currentSong].song);
		self.songPlayed = false;
		if self.currentSong >= self.radioCount then
			self.currentSong = 1;
		else
			self.currentSong = self.currentSong + 1;
		end;
	end;
	
	if isDown and sym == Input.KEY_f7 then
		stopSample(self.radio[self.currentSong].song);
		self.songPlayed = false;
		if self.currentSong <= 1 then
			self.currentSong = self.radioCount;
		else
			self.currentSong = self.currentSong - 1;
		end;
	end;
	
	-- Ende Radio
	
    if isDown and sym == Input.KEY_0 then
		self.helpPanel = not self.helpPanel;
	end;	
end;

function RadioBox:update(dt)
	-- Anfang Radio
	
	if self.radioVolume <= 0 then
		self.radioVolume = 0.1;
	end;
	if self.radioOn then
		if not self.songPlayed then
			playSample(self.radio[self.currentSong].song, 1, self.radioVolume, 0);
			self.songKoniec = self.time + getSampleDuration(self.radio[self.currentSong].song);
			self.songPlayed = true;
		end;
		if self.time >= self.songKoniec then
			if self.currentSong == self.radioCount then
				self.currentSong = 1;
			else
				self.currentSong = self.currentSong + 1;
			end;
			self.songPlayed = false;
		end;
	else
		if self.songPlayed then
			stopSample(self.radio[self.currentSong].song, 0, 1, 0);
			self.songPlayed = false;
		end;
	end;		
	
	-- Ende Radio
end;

function RadioBox:draw()
	-- Anfang Info Panel
	if self.isEntered then
		if not self.helpPanel then
			renderText(0.8335, 0.15, 0.02, "Taste 0: Info Einschalten");
		else
			renderText(0.8335, 0.15, 0.02, "Taste 0: Info Abschalten");
		end;
		if self.helpPanel then
			renderText(0.72, 0.72, 0.025, "- Radio -");
			renderText(0.72, 0.705, 0.02, "Taste F5: ein/ausschalten");	
			renderText(0.72, 0.69, 0.02, "Taste F6: nchster Track");			
			renderText(0.72, 0.675, 0.02, "Taste F7: vorheriger Track");			
		end;
	end;

		--Ende Info Panel
end;

function RadioBox:onEnter()
end;

function RadioBox:onLeave()
	-- Anfang Radio
	
	self.radioOn = false;
	
	-- Ende Radio
end;

function RadioBox:delete()
end;

function RadioBox:mouseEvent(posX, posY, isDown, isUp, button)
end;

function key_convert(key)
    if key ~= nil then 
	    local keyname = "";
	    if key > 32 and key < 123 then
	    	keyname = string.upper(string.char(key));
	    elseif key > 255 and key < 266 then
	    	keyname = "NUM "..string.char(key-208);
	    else 
	    	keyname = "";
	    end;
	    return(keyname);
	  end;
end;